From b0d3a719e35468b9583ff7c2be02fd969d05c50b Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Thu, 9 Apr 2020 21:18:33 +0300
Subject: [PATCH 15/59] AlpineApkBackend: mark pkgs as Technical type and fix
 searhes

This makes updates appear as "System updates" in updates view
and also makes them correctly categorized in top level
categories when other backend is installed (Flatpak, KNewStuff)
---
 .../AlpineApkBackend/AlpineApkBackend.cpp     | 62 ++++++++++++-------
 .../AlpineApkBackend/AlpineApkResource.cpp    |  2 +-
 2 files changed, 42 insertions(+), 22 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
index 757380186..750d2820c 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
@@ -79,9 +79,12 @@ AlpineApkBackend::AlpineApkBackend(QObject *parent)
     if (m_availablePackages.size() > 0) {
         for (const QtApk::Package &pkg: m_availablePackages) {
             AlpineApkResource *res = new AlpineApkResource(pkg, this);
-            res->setCategoryName(QStringLiteral("all"));
+            res->setCategoryName(QStringLiteral("alpine_packages"));
             res->setOriginSource(QStringLiteral("apk"));
             res->setSection(QStringLiteral("dummy"));
+            // here is the place to set a proper type of package
+            // AlpineApkResource defaults to AbstractResource::Technical,
+            // which places it into "System updates" section
             const QString key = pkg.name.toLower();
             m_resources.insert(key, res);
             connect(res, &AlpineApkResource::stateChanged, this, &AlpineApkBackend::updatesCountChanged);
@@ -105,18 +108,22 @@ AlpineApkBackend::AlpineApkBackend(QObject *parent)
 
 QVector<Category *> AlpineApkBackend::category() const
 {
-    // single root category
+    static QPair<FilterType, QString> s_apkFlt(
+                FilterType::CategoryFilter, QLatin1String("alpine_packages"));
+
+    // Display a single root category
     // we could add more, but Alpine apk does not have this concept
-    static Category *cat = new Category(
-                i18nc("Root category name", "Alpine packages"),
-                QStringLiteral("package-x-generic"), // icon
-                {},                // orFilters
-                { displayName() }, // pluginName
-                {},                // subCategories
-                QUrl(),            // decoration (what is it?)
-                false              // isAddons
+    static Category *s_rootCat = new Category(
+            i18nc("Root category name", "Alpine packages"),
+            QStringLiteral("package-x-generic"), // icon
+            { s_apkFlt },      // orFilters - include packages that match filter
+            { displayName() }, // pluginName
+            {},                // subCategories - none
+            QUrl(),            // decoration (what is it?)
+            false              // isAddons
     );
-    return { cat };
+
+    return { s_rootCat };
 }
 
 int AlpineApkBackend::updatesCount() const
@@ -130,17 +137,23 @@ ResultsStream *AlpineApkBackend::search(const AbstractResourcesBackend::Filters
     if (!filter.resourceUrl.isEmpty()) {
         return findResourceByPackageName(filter.resourceUrl);
     } else {
-        for (AbstractResource *r: qAsConst(m_resources)) {
-            if (r->type() == AbstractResource::Technical
-                    && filter.state != AbstractResource::Upgradeable) {
-                continue;
-            }
-            if (r->state() < filter.state) {
+        for (AbstractResource *resource: qAsConst(m_resources)) {
+            // skip technical package types (not apps/addons)
+            //      that are not upgradeable
+            //  (does not work because for now all Alpine packages are "technical"
+            // if (resource->type() == AbstractResource::Technical
+            //         && filter.state != AbstractResource::Upgradeable) {
+            //     continue;
+            // }
+
+            // skip not-requested states
+            if (resource->state() < filter.state) {
                 continue;
             }
-            if(r->name().contains(filter.search, Qt::CaseInsensitive)
-                    || r->comment().contains(filter.search, Qt::CaseInsensitive)) {
-                ret += r;
+
+            if(resource->name().contains(filter.search, Qt::CaseInsensitive)
+                    || resource->comment().contains(filter.search, Qt::CaseInsensitive)) {
+                ret += resource;
             }
         }
     }
@@ -162,7 +175,7 @@ ResultsStream *AlpineApkBackend::findResourceByPackageName(const QUrl &searchUrl
     AlpineApkResource *result = nullptr;
 
     // QUrl("appstream://org.kde.krita.desktop")
-    // smart workaround for appstream URLs
+    // smart workaround for appstream URLs - handle "featured" apps
     if (searchUrl.scheme()  == QLatin1String("appstream")) {
         // remove leading "org.kde."
         QString pkgName = searchUrl.host();
@@ -177,6 +190,13 @@ ResultsStream *AlpineApkBackend::findResourceByPackageName(const QUrl &searchUrl
         result = m_resources.value(pkgName);
     }
 
+    // QUrl("apk://krita")
+    // handle packages from Alpine repos
+    if (searchUrl.scheme() == QLatin1String("apk")) {
+        const QString pkgName = searchUrl.host();
+        result = m_resources.value(pkgName);
+    }
+
     if (!result) {
         return new ResultsStream(QStringLiteral("AlpineApkStream"), {});
     }
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp
index af480b6c6..346a28b28 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp
@@ -26,7 +26,7 @@ AlpineApkResource::AlpineApkResource(const QtApk::Package &apkPkg,
                                      AbstractResourcesBackend *parent)
     : AbstractResource(parent)
     , m_state(AbstractResource::State::None)
-    , m_type(Application)
+    , m_type(AbstractResource::Type::Technical)
     , m_pkg(apkPkg)
 {
 }
-- 
GitLab


